﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows.Data;

namespace RadTabControlExample
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            ObservableCollection<DataItem> items = new ObservableCollection<DataItem>();
            items.Add(new DataItem("First", true) { Description = "First item Description"});
            items.Add(new DataItem("Second", false) { Description = "Second item Description"});
            items.Add(new DataItem("Third", true) { Description = "third item description"});

            tabControl.ItemsSource = items;
        }

        private void tabControl_PreviewSelectionChanged(object sender, Telerik.Windows.Controls.SelectionChangedEventArgs e)
        {
            var tabItem = e.AddedItems[0] as DataItem;
            if (!tabItem.IsValid)
            {
                e.Handled = true;
            }
        }

        private void TextBox_TextChanged(object sender, TextChangedEventArgs e)
        {
            TextBox textBox = sender as TextBox; 
            BindingExpression binding = textBox.GetBindingExpression(TextBox.TextProperty); 
            binding.UpdateSource(); 
        }
    }

    public class DataItem : INotifyPropertyChanged
    {
        public DataItem(string name, bool isValid)
        {
            this.Name = name;
            this.IsValid = isValid;
        }

        #region MyProperty (INotifyPropertyChanged Property)
        private string description;

        public string Description
        {
            get { return description; }
            set
            {
                description = value;
                RaisePropertyChanged("Description");
            }
        }
        #endregion
        

        #region INotifyPropertyChanged values

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion


        public string Name { get; set; }
        public bool IsValid { get; set; }
    }
}
